<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/07/2019
 * Time: 07:05
 */
require_once "MainController.php";
require_once "../Models/ProductSummaryModel.php";
class ProductSummaryController extends MainController
{

    public function create_summary ($product_id){

        if (isset($product_id)){

            if ($product_id == "" || !is_numeric($product_id)){

                return "Invalid Product ID";

            } else {

                $use_product = new ProductSummaryModel();
                return $use_product->create_summary($product_id);

            }

        } else {

            return "Product ID required";
        }

    }


    public function view_summary(){

        $use_product = new ProductSummaryModel();
        return $use_product->get_all_summary();

    }


    public function update_transactions($product_id, $tran_type, $quantity, $amount){
        //credit - 1 , debit - 2
        if (isset($product_id) && isset($tran_type)){

            if (is_numeric($product_id) && is_numeric($tran_type) && is_numeric($quantity) && is_numeric($amount)) {

                if($product_id > 0 && $quantity > 0 && $amount > 0) {
                    if ($tran_type == 1 || $tran_type == 2) {


                        $use_product = new ProductSummaryModel();
                        $use_product->auto_commit_off();
                        $get_data = $use_product->get_single_summary($product_id);

                        if (is_array($get_data)) {
//                            echo json_encode($get_data);
//                            echo "<hr>";
                            $total_quantity_in = $get_data['total_voucher_in'];
                            $total_quantity_out = $get_data['total_voucher_used'];
                            $total_amount_in = $get_data['total_amount_in'];
                            $total_amount_out = $get_data['total_amount_used'];

                            if ($tran_type == 1) {
                                $summary_quantity_in = (int)$total_quantity_in + (int)$quantity;
                                $summary_amount_in = (float)$total_amount_in + (float)$amount;

                                $update_summary = $use_product->update_summary($product_id,$summary_quantity_in, "", $summary_amount_in);

                                if (is_array($update_summary)){
                                    $use_product->commit_now();
                                    $r_array = array();
                                    $r_array['id'] = $product_id;
                                    $r_array['total_quantity_in'] = $summary_quantity_in;
                                    $r_array['total_amount_in'] = $summary_amount_in;
                                    return $r_array;
                                } else {
                                    $use_product->rollback_now();
                                    return $update_summary;
                                }
                            } elseif ($tran_type == 2){

                                $summary_quantity_out = (int)$total_quantity_out + (int)$quantity;
                                $summary_amount_out = (float)$total_amount_out + (float)$amount;

                                $update_summary = $use_product->update_summary($product_id,"", $summary_quantity_out, "", $summary_amount_out);

                                if (is_array($update_summary)){
                                    $use_product->commit_now();
                                    $r_array = array();
                                    $r_array['id'] = $product_id;
                                    $r_array['total_quantity_out'] = $summary_quantity_out;
                                    $r_array['total_amount_out'] = $summary_amount_out;
                                    return $r_array;
                                } else {
                                    $use_product->rollback_now();
                                    return $update_summary;
                                }
                            } else {

                                return "Invalid Tran type";
                            }
                        } else {

                            return "Unable to fetch Summary";
                        }

                    } else {

                        return "Invalid Transaction Type";
                    }
                } else {

                    return "Values must be greater than 0";
                }
            } else {

                return "Numeric values required for parameters";
            }
        } else {

            return "Product ID and Transaction Type required";
        }
    }


    public function view_total_summary(){

        $get_detail = $this->view_summary();

        if(is_array($get_detail)){
            $r_array = array();
            $r_array['used_voucher'] = 0;
            $r_array['uploaded_voucher'] = 0;
            $r_array['available'] = 0;

            $r_array['used_amount'] = 0;
            $r_array['uploaded_amount'] = 0;
            $r_array['available_amount'] = 0;
            foreach($get_detail['data'] as $detail){

                $r_array['used_voucher'] = $r_array['used_voucher'] + $detail['total_voucher_used'];
                $r_array['uploaded_voucher'] = $r_array['uploaded_voucher'] + $detail['total_voucher_in'];
                $r_array['available'] =  $r_array['available'] + ($detail['total_voucher_in'] - $detail['total_voucher_used']);

                $r_array['used_amount'] = $r_array['used_amount'] + $detail['total_amount_used'];
                $r_array['uploaded_amount'] = $r_array['uploaded_amount'] + $detail['total_amount_in'];
                $r_array['available_amount'] = $r_array['available_amount'] +( $detail['total_amount_in'] - $detail['total_amount_used']);

            }

            $get_detail['totals'] = $r_array;

            return $get_detail;
        } else {

            return "Error Processing";
        }



    }
}

//$page_test = new ProductSummaryController();
//echo json_encode($page_test->view_total_summary());
//echo json_encode($page_test->create_summary(2));
//echo json_encode($page_test->update_transactions(1,2,1,600));