<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 23/06/2019
 * Time: 12:58
 */
require_once "MainController.php";
require_once "VoucherController.php";
require_once "TransactionController.php";
require_once "ProductSummaryController.php";
require_once "../Models/ProductTypeModel.php";
class ProductTypeController extends MainController
{


    public function add_products($product_amount){
        $today_date = Date('Y-m-d H:i:s');
        if (isset($product_amount)){

            if ($product_amount == ""){

                return "Blank Amount";
            } else {

                if(is_numeric($product_amount) && $product_amount > 0){

                    $product_code = "UBER-".$product_amount;
                    $product_name = "UBER VOUCHER(".$product_amount.")";
                    $use_products = new ProductTypeModel();
                    $add_uber = $use_products->add_products($product_name,$product_code, $product_amount, $today_date,1);
                    $use_summary = new ProductSummaryController();

                    if (is_array($add_uber)){
                        $use_summary->create_summary($add_uber['id']);
                        return $add_uber;

                    } else {

                        return $add_uber;
                    }
                } else {

                    return "Invalid Product Amount";
                }
            }

        } else {

            return "Missing Amount";
        }


    }


    public function edit_product ($product_id, $product_amount){

        if (isset($product_id) && isset($product_amount)){


            if ($product_id == "" || $product_amount == ""){

                return "Blank id or amount";
            } else {

                if(is_numeric($product_amount) && $product_amount > 0){

                    $product_code = "UBER-".$product_amount;
                    $product_name = "UBER VOUCHER(".$product_amount.")";
                    $use_product = new ProductTypeModel();
                    $get_product = $use_product->get_single_product($product_id);

                    if(is_array($get_product)){

                        return $use_product->update_product($product_id, "",$product_name, $product_code, $product_amount);

                    } else {

                        return "Invalid Product";
                    }

                } else {

                    return "Invalid Product amount";
                }

            }

        } else {

            return "Missing id or amount";
        }


    }


    public function disable_product ($product_id){

        if(isset($product_id)){

            return $this->change_status_product($product_id, "0");

        } else {

            return "Missing Product";
        }

    }

    public function enable_product ($product_id){

        if(isset($product_id)){

            return $this->change_status_product($product_id, 1);

        } else {

            return "Missing Product";
        }

    }


    private function change_status_product ($product_id, $status){

        if (isset($product_id) && isset($status)){


            if ($product_id == "" ){

                return "Blank id";
            } else {

                if($status == 0 || $status == 1){

                    $use_product = new ProductTypeModel();
                    $get_product = $use_product->get_single_product($product_id);

                    if(is_array($get_product)){

                        if ($status == $get_product['status']){
                         return "Current product status sent";

                        } else {
                            return $use_product->update_product($product_id, $status);
                        }
                    } else {

                        return "Invalid Product";
                    }

                } else {

                    return "Invalid Status";
                }

            }

        } else {

            return "Missing id";
        }


    }



    public function list_products(){
        $use_products = new ProductTypeModel();
        $get_products = $use_products->get_products();

        if (is_array($get_products)){

            if (isset($get_products['data'])){

                $response_array = array();
                foreach ($get_products['data'] as $product){

                    if ($product['status'] == 1) {
                        $r_array = array();
                        $r_array['id'] = $product['product_id'];
                        $r_array['code'] = $product['product_code'];
                        $r_array['name'] = $product['product_name'];
                        $r_array['price'] = $product['product_amount'];
                        $r_array['max_no'] = $product['max_quantity'];

                        $response_array[] = $r_array;
                    }

                }

                return $response_array;
            } else {

                return "Error receiving data";
            }

        } else {

            return "No product Found";
        }


    }


    public function list_all_products(){
        $use_products = new ProductTypeModel();
        $get_products = $use_products->get_products();

        if (is_array($get_products)){

            if (isset($get_products['data'])){

                $response_array = array();
                foreach ($get_products['data'] as $product){


                        $r_array = array();
                        $r_array['id'] = $product['product_id'];
                        $r_array['code'] = $product['product_code'];
                        $r_array['name'] = $product['product_name'];
                        $r_array['price'] = $product['product_amount'];
                        $r_array['max_no'] = $product['max_quantity'];
                        $r_array['voucher'] = $product['voucher'];
                        $r_array['status'] = $product['status'];

                        $response_array[] = $r_array;


                }

                return $response_array;
            } else {

                return "Error receiving data";
            }

        } else {

            return "No product Found";
        }


    }


    public function purchase_product($product_code, $price, $quantity, $email, $reference, $phone =null){
        if (isset($product_code) && isset($price) && isset($quantity) && isset($email) && isset($reference)){


            if ($product_code == "" || $price == ""|| $quantity == "" || $email== "" || $reference == ""){

                return "Blank Parameters";
            } else {

                if(is_numeric($price) && $price > 0) {
                    if (filter_var($email, FILTER_VALIDATE_EMAIL)) {

                        if (is_numeric($quantity) && $quantity > 0) {

                            $use_product = new ProductTypeModel();
                            $check_price = $use_product->get_single_product("", $product_code);

                            if (is_array($check_price)) {

                                if ($price == $check_price['product_amount']) {
                                    $use_voucher = new VoucherController();

                                    $get_vouchers = $use_voucher->purchase_voucher($check_price['product_id'], $quantity);

                                    if (is_array($get_vouchers)) {
                                        $use_tran = new TransactionController();
                                        $save_tran = $use_tran->insert_multi_transactions($get_vouchers, $email, $phone, $reference);

                                        return $save_tran;


                                    } else {

                                        return $get_vouchers;
                                    }

                                } else {

                                    return "Invalid Price";
                                }

                            } else {

                                return "Invalid Product";
                            }

                        } else {

                            return "Invalid Quantity";
                        }

                    } else {

                        return "Invalid Email address";
                    }
                } else {

                    return "Invalid Price.";
                }

            }

        } else {

            return "Missing Parameter";
        }



    }

}

//$page_test = new ProductTypeController();
//echo json_encode($page_test->enable_product(1));
//echo json_encode($page_test->purchase_product("UBER-600", "600", 2, "jane@asmith.com", "XYZ123", ""));
//echo json_encode($page_test->edit_product(1, 600));
//echo json_encode($page_test->list_products());
//echo json_encode($page_test->add_products(1500));