<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 23/06/2019
 * Time: 16:13
 */

require_once "MainController.php";
require_once "../Models/UploadModel.php";
require_once "ProductTypeController.php";
require_once "FailedTransactionController.php";
class UploadController extends MainController
{

    private $report_path = "../reports/";



    public function upload_file($file){
        if (isset($file)) {



            $filename = $file['name'];
//            echo $filename;
            $filename0 = basename($filename, ".csv");
            $ext_file = explode('.', $file['name']);
            $file_ext = strtolower(end($ext_file));
            $file_size = $file["size"];

            $extensions = array(
                "csv"
            );
            if (in_array($file_ext, $extensions) === false)
            {
                return "File must be CSV";

            } else {

                //$filecheck = substr($file,0,5);

                //$response_array['status'] = "working2";
                if ($file['size'] < (5120000)) {

                    // if file is ok
                    $create_report = 0;

                    $create_report = $this->upload_vouchers($filename);



                    if(is_array($create_report)) {


                        if (move_uploaded_file($file["tmp_name"], $this->report_path.$filename)) {
                            return $create_report;
                        }// sucessful
                        else {

                            return "Error moving file to upload location";
                        }// error moving file

                    } else {

                        return "$create_report";
                    }
                }

                else {
                    return "File is too large. Must be less than 2 MB";
                }// file size check


            }// file extension check

        } else {

            return "Missing parameters";
        }



    }


    private function upload_vouchers($file_name){
        $today_date = Date('Y-m-d H:i:s');
        if (isset($file_name)){

            if ($file_name == ""){

                return "Blank file name";
            } else {

                $use_upload = new UploadModel();
                return $use_upload->upload_file($file_name, $today_date,0);

            }
        } else {

            return "Missing file name";
        }
    }


    public function get_all_upload() {
        $use_upload = new UploadModel();
        return $use_upload->get_upload_report();

    }

    public function run_upload_file ($file_id){
        if(isset($file_id)){

            if ($file_id == ""){

                return "Blank file selected";
            } else {

                $use_upload = new UploadModel();
                $check_file = $use_upload->get_single_report($file_id);
                if (is_array($check_file)){

                    if ($check_file['status'] == 0){

                        $mark_file = $use_upload->update_file($file_id, 1);
                        if (is_array($mark_file)){

                            $run_file = $this->convert_csv_json($check_file['file_name']);

                            if(is_array($run_file)){
                                $total = count($run_file);
                                $check_data = $this->check_array_transaction($run_file);

//                                echo json_encode($check_data);
//                                echo "<hr>";
                                $save_failed= new FailedTransactionController();
                                if(is_array($check_data)){
                                    $success_count = 0;
                                    if(!empty($check_data['success'])){
                                        $use_voucher = new VoucherController();


                                        foreach ($check_data['success'] as $good_voucher){

                                            $save_voucher = $use_voucher->create_vouchers($good_voucher['id'], $file_id, $good_voucher['amount'], $good_voucher['voucher']);

                                            if(is_array($save_voucher)){

                                                $success_count = $success_count + 1;
                                            } else {
                                                $good_voucher['info'] = $save_voucher;
                                                $save_failed->create_failed($file_id, $good_voucher);

                                            }
                                        }


                                    }

                                    if(!empty($check_data['failed'])){
                                        foreach ($check_data['failed'] as $f_data){

                                            $save_failed->create_failed($file_id, $f_data);

                                        }

                                    }

                                    $return_array = array();
                                    $return_array['success'] = $success_count;
                                    $return_array['total'] = $total;
                                    return $return_array;
                                } else {

                                    return "Error checking data";
                                }


                            } else {

                                return "Invalid file data";
                            }

                        } else {

                            return "Error updating upload file status";
                        }


                    } else {

                        return "File has been processed before";
                    }

                } else {

                    return "Invalid File";
                }

            }
        } else {

            return "File Identifier required";
        }

    }


    private function convert_csv_json($file_name){

        if (strlen($file_name) >4){

            $csv = file_get_contents($this->report_path.$file_name);
            $array = array_map("str_getcsv",explode("\n",$csv));
            return $array;


        } else {

            return "Invalid file name";
        }
    }


    private function check_array_transaction($voucher_array)
    {

        $success_array = array();
        $failed_array = array();

        $use_product = new ProductTypeController();
        $products = $use_product->list_products();
//        echo json_encode($products);
//        echo "<hr>";


                if(is_array($voucher_array)){

                    foreach ($voucher_array as $trans){
                        if (isset($trans[1]) && isset($trans[2])) {
                            $each_array = array();
                            if ($trans[1] == "" || $trans[1] == null) {

                                $each_array['voucher'] = $trans[1];
                                $each_array['info'] = "Missing Voucher no";

                            } else {



                                $each_array['voucher'] = $trans[1];

                            }

                            if ($trans[2] == "" || $trans[2] == null || !is_numeric($trans[2])) {

                                $each_array['amount'] = $trans[2];
                                $each_array['info'] = "Invalid amount value";

                            } else {

                                $check_amount = $this->check_array($trans[2], $products);
                                if($check_amount > 0) {

                                    $each_array['amount'] = $trans[2];
                                    $each_array['id'] = $check_amount;
                                } else {

                                    $each_array['amount'] = $trans[2];
                                    $each_array['info'] = "Amount value not found";

                                }
                            }



                            if (isset($each_array['info'])) {

                                $failed_array[] = $each_array;
                            } else {

                                $success_array[] = $each_array;
                            }
                        }
                    }

                    $response_array = array();
                    $response_array['success'] = $success_array;
                    $response_array['failed'] = $failed_array;

                    return $response_array;


                } else {

                    return "Invalid transaction data";
                }


    }


    private function check_array ($amount, $array){

//        echo json_encode($array);
//        echo "<hr>";
//        echo $amount;
        foreach ($array as $p_array){

            if ($p_array['price'] == $amount){

                return $p_array['id'];
            }
        }

        return 0;
    }
}

//$page_test = new UploadController();
//echo json_encode($page_test->run_upload_file(1));
//echo json_encode(($page_test->get_all_upload()));
//echo json_encode($page_test->upload_file("uber_test.csv"));