<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/07/2019
 * Time: 06:30
 */
require_once "DatabaseModel.php";
class ProductSummaryModel extends DatabaseModel
{

    private $table = "uber_product_summary";
    private $product_table = "uber_products";

    public function create_summary ($product_id){

        $column = array("product_id");
        $value = array($product_id);

        $u_where['column_name'] = "product_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $product_id;
        $where[] = $u_where;

        $insert_data = $this->insert_check_duplicate($this->table, $column, $value, $where);

        if (is_numeric($insert_data) && $insert_data > 0){

            $n_array = array();
            $n_array['id'] = $insert_data;


            return $n_array;

        } elseif($insert_data == 0) {

            return "Error inserting data";
        } else {

            return "Product already exists";
        }

    }


    public function update_summary($product_id, $total_voucher_in = null, $total_voucher_out = null, $total_amount_in = null, $total_amount_out = null){


        if ($total_voucher_in != null){

            $firstset['column_name'] = "total_voucher_in";
            $firstset['sign'] = "=";
            $firstset['value'] = $total_voucher_in;
            $set[] = $firstset;

        }

        if ($total_voucher_out != null){

            $firstset['column_name'] = "total_voucher_used";
            $firstset['sign'] = "=";
            $firstset['value'] = $total_voucher_out;
            $set[] = $firstset;

        }

        if ($total_amount_in != null){

            $firstset['column_name'] = "total_amount_in";
            $firstset['sign'] = "=";
            $firstset['value'] = $total_amount_in;
            $set[] = $firstset;

        }


        if ($total_amount_out != null){

            $firstset['column_name'] = "total_amount_used";
            $firstset['sign'] = "=";
            $firstset['value'] = $total_amount_out;
            $set[] = $firstset;

        }


        $u_where['column_name'] = "product_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $product_id;
        $where[] = $u_where;

        if(isset($set)) {
            $update_data = $this->update_data($this->table, $set, $where);
            if ($update_data == 1) {
                $d_array['id'] = $product_id;

                return $d_array;
            } else {

                return "Unable to process request";
            }
        } else {

            return "No update parameter sent";
        }
    }



    public function get_single_summary($product_id){

        $columns = array("total_voucher_in", "total_voucher_used", "total_amount_in", "total_amount_used");

        $u_where['column_name'] = "product_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $product_id;
        $where[] = $u_where;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "No data found";
        }

    }


    public function get_all_summary(){

        $columns = array("product_code", "product_name","total_voucher_in", "total_voucher_used", "total_amount_in", "total_amount_used", "(total_voucher_in - total_voucher_used) AS total_available");

        $firstjoin ['table_name'] = $this->product_table;
        $firstjoin ['first_column'] = $this->table.".product_id";
        $firstjoin ['second_column'] = $this->product_table . ".product_id";
        $leftjoin [] = $firstjoin;

        $get_data = $this->select_tb($this->table, $columns,"","","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data;

        } else {

            return "No data found";
        }

    }


}

//$page_test = new ProductSummaryModel();
//echo json_encode($page_test->update_summary(1, 2,"",1200));
//echo json_encode($page_test->get_all_summary());