<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 22/06/2019
 * Time: 08:20
 */

require_once "DatabaseModel.php";
class ProductTypeModel extends DatabaseModel
{

    private $table = "uber_products";
    private $summary_table = "uber_product_summary";


    public function add_products($product_name, $product_code, $product_amount, $create_date, $status)
    {

        $columns = array("product_name","product_code","product_amount","create_date","status");
        $values = array($product_name, $product_code, $product_amount, $create_date, $status);

        $u_where['column_name'] = "product_amount";
        $u_where['sign'] = "=";
        $u_where['value'] = $product_amount;
        $where[] = $u_where;

        $insert_data = $this->insert_check_duplicate($this->table, $columns, $values,$where);

        if (is_numeric($insert_data) && $insert_data > 0) {

            $n_array = array();
            $n_array['id'] = $insert_data;
            $n_array['product'] = $product_name;
            $n_array['code'] = $product_code;
            $n_array['amount'] = $product_amount;

            return $n_array;

        }elseif ($insert_data < 0){

            return "Amount already exists";
        } else {

            return "Error inserting data";
        }


    }


    public function get_products(){


        $columns = array($this->table.".product_id","product_name", "product_code","product_amount","create_date","status", "(total_voucher_in - total_voucher_used) AS max_quantity");

        $firstjoin ['table_name'] = $this->summary_table;
        $firstjoin ['first_column'] = $this->table.".product_id";
        $firstjoin ['second_column'] = $this->summary_table . ".product_id";
        $leftjoin [] = $firstjoin;

        $get_data = $this->select_tb($this->table, $columns, "","","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data;

        } else {

            return "No data found";
        }



    }


    public function get_single_product($product_id = null, $product_code = null, $product_amount = null){


        $columns = array("product_id","product_name","product_code", "product_amount","create_date","status");


        if ($product_id != "" || $product_id !=null) {
            $u_where['column_name'] = "product_id";
            $u_where['sign'] = "=";
            $u_where['value'] = $product_id;
            $where[] = $u_where;
        }


        if ($product_code != "" || $product_code !=null) {
            $u_where['column_name'] = "product_code";
            $u_where['sign'] = "=";
            $u_where['value'] = $product_code;
            $where[] = $u_where;
        }

        if ($product_amount != "" || $product_amount !=null) {
            $u_where['column_name'] = "product_amount";
            $u_where['sign'] = "=";
            $u_where['value'] = $product_amount;
            $where[] = $u_where;
        }

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "No data found";
        }



    }

//    public function get_single_product_code($product_code){
//
//
//        $columns = array("product_id","product_name","product_code", "product_amount","create_date","status");
//
//
//
//            $u_where['column_name'] = "product_code";
//            $u_where['sign'] = "=";
//            $u_where['value'] = $product_code;
//            $where[] = $u_where;
//
//
//
//            $u_where['column_name'] = "status";
//            $u_where['sign'] = "=";
//            $u_where['value'] = 0;
//            $where[] = $u_where;
//
//
//        $get_data = $this->select_tb($this->table, $columns, $where);
//
//        if (is_array($get_data)){
//
//            return $get_data['data'];
//
//        } else {
//
//            return "No data found";
//        }
//
//
//
//    }

    public function update_product ($product_id, $status = null, $product_name = null, $product_code = null, $product_amount = null)
    {



        if ($status != "" || $status != "") {
            $firstset['column_name'] = "status";
            $firstset['sign'] = "=";
            $firstset['value'] = $status;
            $set[] = $firstset;
        }

        if ($product_name != "" || $product_name != "") {
            $firstset['column_name'] = "product_name";
            $firstset['sign'] = "=";
            $firstset['value'] = $product_name;
            $set[] = $firstset;
        }

        if ($product_code != "" || $product_code != "") {
            $firstset['column_name'] = "product_code";
            $firstset['sign'] = "=";
            $firstset['value'] = $product_code;
            $set[] = $firstset;
        }

        if ($product_amount != "" || $product_amount != "") {
            $firstset['column_name'] = "product_amount";
            $firstset['sign'] = "=";
            $firstset['value'] = $product_amount;
            $set[] = $firstset;
        }

        $u_where['column_name'] = "product_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $product_id;
        $where[] = $u_where;

        if(isset($set)) {
            $update_data = $this->update_data($this->table, $set, $where);
            if ($update_data == 1) {
                $d_array['id'] = $product_id;

                return $d_array;
            } else {

                return "Unable to process request";
            }
        } else {

            return "No update parameter sent";
        }

    }
}


//$page_test = new ProductTypeModel();
//echo json_encode($page_test->get_products());