<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 22/06/2019
 * Time: 15:08
 */

require_once "DatabaseModel.php";
class TransactionModel extends DatabaseModel
{

    private $table = "uber_transactions";
    private $voucher_table = "uber_vouchers";


    public function get_transactions(){


        $columns = array("tran_id", "email", "phone_no", "reference", $this->table.".create_date", "price", "voucher");


        $firstjoin ['table_name'] = $this->voucher_table;
        $firstjoin ['first_column'] = $this->table.".voucher_id";
        $firstjoin ['second_column'] = $this->voucher_table . ".voucher_id";
        $leftjoin [] = $firstjoin;

        $get_data = $this->select_tb($this->table, $columns, "","","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data;

        } else {

            return "No data found";
        }



    }


    public function add_transactions($voucher_id, $email, $phone_no, $reference, $create_date){


        $columns = array("voucher_id", "email", "phone_no", "reference", "create_date");
        $values = array($voucher_id, $email, $phone_no, $reference, $create_date);


        $u_where['column_name'] = "reference";
        $u_where['sign'] = "=";
        $u_where['value'] = $reference;
        $where[] = $u_where;
        $insert_data = $this->insert_data($this->table, $columns, $values);

        if (is_numeric($insert_data) && $insert_data > 0){

            $n_array = array();
            $n_array['id'] = $insert_data;
            $n_array['reference'] = $reference;

            return $n_array;

        } elseif($insert_data == 0) {

            return "Error inserting data";
        } else {

            return "Reference already exists";
        }

    }


    public function month_transactions(){

        $column = array("Month(".$this->table.".create_date) AS order_month","sum(quantity) as total_items","sum(price* quantity) as total_value");

        $firstjoin ['table_name'] = $this->voucher_table;
        $firstjoin ['first_column'] = $this->table.".voucher_id";
        $firstjoin ['second_column'] = $this->voucher_table . ".voucher_id";
        $leftjoin [] = $firstjoin;

        $group = array("MONTH(".$this->table.".create_date)");

//        $first_where['column_name'] = "status";
//        $first_where['sign'] = "=";
//        $first_where['value'] = 2;
//        $where[] = $first_where;
//
//        $first_where['column_name'] = "company_id";
//        $first_where['sign'] = "=";
//        $first_where['value'] = $company_id;
//        $where[] = $first_where;

//        $first_where['column_name'] = "MONTH(".$this->table.".create_date)";
//        $first_where['sign'] = "=";
//        $first_where['value'] = "MONTH(CURRENT_DATE())";
//        $where[] = $first_where;

        $first_where['column_name'] = "YEAR(".$this->table.".create_date)";
        $first_where['sign'] = "=";
        $first_where['value'] = "YEAR(CURRENT_DATE())";
        $where[] = $first_where;

        $get_data = $this->select_tb($this->table, $column, $where, "",$group,"","","",$leftjoin);

        if (is_array($get_data)) {


            return $get_data['data'];
        } else {

            return "No data found";
        }

    }
}

//$page_test = new TransactionModel();
//echo json_encode($page_test->month_transactions());