<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 22/06/2019
 * Time: 15:36
 */

require_once "DatabaseModel.php";
class VoucherModel extends DatabaseModel
{

    private $table = "uber_vouchers";
    private $product_table = "uber_products";

    public function get_vouchers(){

        $columns = array("voucher_id", $this->table .".product_id", "product_code", "product_name","product_amount", "voucher",$this->table.".status", $this->table.".create_date", $this->table.".update_date");

        $firstjoin ['table_name'] = $this->product_table;
        $firstjoin ['first_column'] = $this->table.".product_id";
        $firstjoin ['second_column'] = $this->product_table . ".product_id";
        $leftjoin [] = $firstjoin;

        $get_data = $this->select_tb($this->table, $columns, "","","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data;

        } else {

            return "No data found";
        }

    }


    public function create_voucher($product_id, $file_id, $price, $voucher, $status, $create_date){

        $columns = array("product_id", "file_id","price", "voucher", "status", "create_date");
        $values = array($product_id, $file_id, $price, $voucher, $status, $create_date);


        $u_where['column_name'] = "voucher";
        $u_where['sign'] = "=";
        $u_where['value'] = $voucher;
        $where[] = $u_where;
        $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where);

        if (is_numeric($insert_data) && $insert_data > 0){

            $n_array = array();
            $n_array['id'] = $insert_data;
            $n_array['price'] = $voucher;

            return $n_array;

        } elseif($insert_data == 0) {

            return "Error inserting data";
        } else {

            return "Voucher already exists";
        }


    }


    public function get_single_voucher($product_id){


        $columns = array("voucher_id","product_id","price","voucher", "create_date","status","update_date");


        if ($product_id != "" || $product_id !=null) {
            $u_where['column_name'] = "product_id";
            $u_where['sign'] = "=";
            $u_where['value'] = $product_id;
            $where[] = $u_where;
        }

        $u_where['column_name'] = "status";
        $u_where['sign'] = "=";
        $u_where['value'] = 1;
        $where[] = $u_where;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }



    }


    public function update_voucher ($voucher_id, $status)
    {




            $firstset['column_name'] = "status";
            $firstset['sign'] = "=";
            $firstset['value'] = $status;
            $set[] = $firstset;



        $u_where['column_name'] = "voucher_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $voucher_id;
        $where[] = $u_where;

        if(isset($set)) {
            $update_data = $this->update_data($this->table, $set, $where);
            if ($update_data == 1) {
                $d_array['id'] = $voucher_id;

                return $d_array;
            } else {

                return "Unable to process request";
            }
        } else {

            return "No update parameter sent";
        }

    }


    public function get_valid_vouchers($product_id, $quantity){

        $columns = array("voucher_id", "product_id", "price", "voucher","status");

        $u_where['column_name'] = "product_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $product_id;
        $where[] = $u_where;

        $u_where['column_name'] = "status";
        $u_where['sign'] = "=";
        $u_where['value'] = 0;
        $where[] = $u_where;

        $limit = array(0, $quantity);

        $get_data = $this->select_tb($this->table, $columns, $where,"","","",$limit);

        if (is_array($get_data)){

            return $get_data;

        } else {

            return "No data found";
        }

    }
}